<div align="center">
<img src="https://user-images.githubusercontent.com/50536495/170400421-0c3a1711-4484-42b1-995b-ee0095c3c7cb.png" width = "210" height = "210" alt="Get it on F-Droid"/>
  <h1>PixaPencil</a></h1>
  <p>A capable — Kotlin-first — pixel art editor for Android.</p>


[![Discord](https://img.shields.io/badge/Discord-PixaPencil-blue.svg)](https://discord.com/invite/Ytm7WBMNz9)
[![Matrix](https://img.shields.io/badge/Matrix-PixaPencil-green.svg)](https://matrix.to/#/#pixapencil:matrix.org)
[![License](https://img.shields.io/badge/License-MIT-red.svg)](https://choosealicense.com/licenses/mit/)

[<img src="https://github.com/machiav3lli/oandbackupx/blob/034b226cea5c1b30eb4f6a6f313e4dadcbb0ece4/badge_github.png" alt="Get it on GitHub" height="80">](https://github.com/therealbluepandabear/PixaPencil/releases/latest)
</div>

## 📱 Android market
**PixaPencil** will be available soon on the Google Play Store as well as F-Droid.

**Warning: if you have a phone with a _very_ small screen size (e.g. 400x800 Galaxy Core Prime) this app will not work well. Keep that in mind. I am working on making this app more compatible with smaller screen sizes, but for now it's on hold.**

The app is currently in the beta stage, but you are free to download the beta `.apk` files from here:

https://github.com/therealbluepandabear/PixaPencil/releases

The app is also available on the IzzySoft repository:

https://apt.izzysoft.de/fdroid/index/apk/com.therealbluepandabear.pixapencil

PixaPencil is available in either English (US), English (UK/NZ/AU, etc), or Hebrew. It used to have support for more languages but I dropped support for this since there is no demand for the app and I was putting a lot of effort trying to maintain the translations. Plus can't really be bothered to set up a translation service for a small app like this.

## 🖼️ Showcase

![image](https://user-images.githubusercontent.com/50536495/164863846-a2616e20-e7d1-4cf8-a659-ce0ab43586a0.png)
![image](https://user-images.githubusercontent.com/50536495/164864089-84f657b4-c08a-4dd2-bde5-560a4c78e3f1.png)

![image](https://user-images.githubusercontent.com/50536495/164866012-fa1ce32f-aa80-41cc-887c-94ddf09d33f3.png)
![image](https://user-images.githubusercontent.com/50536495/164866021-b992b5e6-b1ff-49f8-a77b-91feab887b23.png)

![image](https://user-images.githubusercontent.com/50536495/164867306-ed7262f8-e33b-45d3-8e04-8ff122d845ba.png)
![image](https://user-images.githubusercontent.com/50536495/164867362-bda11589-5bae-4872-b927-397875b0d35a.png)

![image](https://user-images.githubusercontent.com/50536495/152713363-a873fdd3-ecc6-4939-a495-28c4a35abbdb.png)
![image](https://user-images.githubusercontent.com/50536495/152713464-9049586a-2332-4625-b31d-99d822625879.png)

**If you want to showcase an image of your own please send me an email at therealbluepandabear@gmail.com.**

## 📜 License

To disclaim, this repository is licensed under the MIT license.

For more info go to: https://choosealicense.com/licenses/mit/.

_Do not use the name '**PixaPencil**' in your app/other product._

## 📝 Features (as of May 28, 2022)
- Pencil tool
- Fill tool 
- Line tool
- Rectangle tool
- Outlined rectangle tool
- Square tool
- Outlined square tool
- Circle Tool
- Outlined Circle Tool
- Spray tool
- Polygon tool
- Dither tool
- Shading tool
- Picker tool
- Find and replace by color tool
- Eraser tool
- Pixel grid
- Pixel perfect mode
- 4 symmetry options (horizontal, vertical, quad, octal) 
- Undo
- Redo
- Zoom in
- Zoom out
- Canvas filters (color filter, lighten, darken, invert, grayscale)
- Color palette support
- Brushes
- Ability to select custom colors using a color picker, RGB sliders, or HEX code
- Ability to unfavorite/favorite projects
- Ability to export projects to PNG/JPG/WEBP/TIFF
- Ability to rotate the canvas 90 degrees clockwise and anti-clockwise, as well as 180 degrees
- Ability to save projects in background

Go to https://github.com/therealbluepandabear/PixaPencil/projects to have a look at features we want to add to **PixaPencil**.

# 📓 Translations
If you spot issues with the translation send me an email at therealbluepandabear@gmail.com or open an issue request.

This app has been partially translated to:
- 🇮🇱 Hebrew (by myself), the translation quality is OK.
- 🇫🇷 French (by a user who has wished to remain anonymous), I am unsure about the translation quality, but it should be OK.
- Arabic (by ManeraKai [https://github.com/ManeraKai])

## 📚 Other libraries used
- duanhong169 (https://github.com/duanhong169) - ColorPicker (https://github.com/duanhong169/ColorPicker)
- yshrsmz (https://github.com/yshrsmz) - KeyboardVisibilityEvent (https://github.com/yshrsmz/KeyboardVisibilityEvent) 
- Beyka (https://github.com/Beyka) - Android-TiffBitmapFactory (https://github.com/Beyka/Android-TiffBitmapFactory)
